--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
Lacerate.lua - A module for tracking Lacerate stacks
$Date: 2010-10-16 21:30:00 +0000 (Sat, 16 Oct 2010) $
$Revision: 168 $
Project Version: r172
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "DRUID" then return end

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Lacerate"
local LacerateModule = cpr:NewModule(modName, "AceConsole-3.0", "AceEvent-3.0")
local buff = GetSpellInfo(33745)

function LacerateModule:OnInitialize()
	self.abbrev = "L"
	self.MAX_POINTS = 5
	self.displayName = buff
end

function LacerateModule:OnEnable()
	if not cpr.db.profile.modules[modName].disableGraphics then
		if not self.graphics then
			self.graphics = cpr:MakeGraphicsFrame(modName, self.MAX_POINTS)
		end
		self.graphics:Show()
	end
	if not cpr.db.profile.modules[modName].disableText then
		if not self.text then
			self.text = cpr:MakeTextFrame(modName)
		end
		self.text:Show()
	end
	
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function LacerateModule:OnDisable()
	if self.graphics then self.graphics:Hide() end
	if self.text then self.text:Hide() end
	self:UnregisterAllEvents()
end

function LacerateModule:UNIT_AURA(_, unit)
	if unit ~= "target" then return end
	
	local _, _, _, count = UnitAura("target", buff, nil, "PLAYER|HARMFUL")
	if count then
		local r, g, b = cpr:GetColorByPoints(modName, count)
		for i = count, 1, -1 do
			self.graphics.points[i].icon:SetVertexColor(r, g, b)
			self.graphics.points[i]:Show()
		end
		for j = self.MAX_POINTS, count+1, -1 do
			self.graphics.points[j]:Hide()
		end
		if self.text then self.text:SetNumPoints(count) end
	else
		for i = 1, self.MAX_POINTS do
			self.graphics.points[i]:Hide()
		end
		if self.text then self.text:SetNumPoints("") end
	end
end

function LacerateModule:PLAYER_TARGET_CHANGED()
	self:UNIT_AURA(nil, "target")
end
