--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
ShadowInfusion.lua - A module for tracking Shadow Infusion stacks on a DK's pet
$Date: 2010-08-15 16:33:14 -0500 (Sun, 15 Aug 2010) $
$Revision: 136 $
Project Version: r172
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then return end

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Shadow Infusion"
local ShadowInfusionModule = cpr:NewModule(modName, "AceConsole-3.0", "AceEvent-3.0")
local buff = GetSpellInfo(91342)

function ShadowInfusionModule:OnInitialize()
	self.abbrev = "SI"
	self.MAX_POINTS = 5
	self.displayName = buff
end

function ShadowInfusionModule:OnEnable()
	if not cpr.db.profile.modules[modName].disableGraphics then
		if not self.graphics then
			self.graphics = cpr:MakeGraphicsFrame(modName, self.MAX_POINTS)
		end
		self.graphics:Show()
	end
	if not cpr.db.profile.modules[modName].disableText then
		if not self.text then
			self.text = cpr:MakeTextFrame(modName)
		end
		self.text:Show()
	end
	
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("UNIT_PET")
end

function ShadowInfusionModule:OnDisable()
	if self.graphics then self.graphics:Hide() end
	if self.text then self.text:Hide() end
	self:UnregisterAllEvents()
end

function ShadowInfusionModule:UNIT_AURA(_, unit)
	if unit ~= "pet" then return end
	
	local _, _, _, count = UnitBuff("pet", buff)
	if count then
		local r, g, b = cpr:GetColorByPoints(modName, count)
		for i = count, 1, -1 do
			self.graphics.points[i].icon:SetVertexColor(r, g, b)
			self.graphics.points[i]:Show()
		end
		for j = self.MAX_POINTS, count+1, -1 do
			self.graphics.points[j]:Hide()
		end
		if self.text then self.text:SetNumPoints(count) end
	else
		for i = 1, self.MAX_POINTS do
			self.graphics.points[i]:Hide()
		end
		if self.text then self.text:SetNumPoints("") end
	end
end

function ShadowInfusionModule:UNIT_PET(_, unit)
	if unit == "player" then
		return self:UNIT_AURA(nil, "pet")
	end
end
